CREATE OR REPLACE PACKAGE         APPS_FA_UTIL_API AS


FUNCTION Get_ProRate_Calendar (
  prorate_date_              IN DATE ) RETURN VARCHAR2;
  

FUNCTION Get_Deprn_Calendar (
  deprn_start_date_              IN DATE ) RETURN VARCHAR2;

 
FUNCTION Get_Book_Type_Name (
  book_type_code_              IN VARCHAR2 ) RETURN VARCHAR2;
  
FUNCTION Get_Book_Deprn_Calendar (
  book_type_code_              IN VARCHAR2 ) RETURN VARCHAR2;
    

FUNCTION Get_Book_ProRate_Calendar (
  book_type_code_              IN VARCHAR2 ) RETURN VARCHAR2; 

FUNCTION Get_Deprn_Period_Name (
  book_type_code_              IN VARCHAR2,
  period_counter_                IN NUMBER  ) RETURN VARCHAR2;

FUNCTION Get_Deprn_Period_Counter (
  book_type_code_           IN VARCHAR2,
  period_name_                IN VARCHAR2  ) RETURN NUMBER;
  
FUNCTION Get_Deprn_Period_Name_By_Date (
  book_type_code_              IN VARCHAR2,
  trans_date_                     IN DATE  ) RETURN VARCHAR2;

FUNCTION Get_Deprn_Period_Cal_End_Date (
  book_type_code_           IN VARCHAR2,
  period_name_                IN VARCHAR2  ) RETURN DATE;

FUNCTION Get_Deprn_Period_Start_Date (
  book_type_code_           IN VARCHAR2,
  period_name_                IN VARCHAR2  ) RETURN DATE;

FUNCTION Get_Deprn_Period_End_Date (
  book_type_code_           IN VARCHAR2,
  period_name_                IN VARCHAR2  ) RETURN DATE;
  
FUNCTION Get_Deprn_Period_Param (
  book_type_code_           IN VARCHAR2,
  period_name_                IN VARCHAR2,
  param_                         IN VARCHAR2  ) RETURN VARCHAR2;
    
FUNCTION Get_Category_Segments (
  category_id_              IN NUMBER ) RETURN VARCHAR2;


FUNCTION Get_Category_Segment1 (
  category_id_              IN NUMBER ) RETURN VARCHAR2;  


FUNCTION Get_Category_Segment2 (
  category_id_              IN NUMBER ) RETURN VARCHAR2;  


FUNCTION Get_Asset_Description (
  asset_id_              IN NUMBER ) RETURN VARCHAR2;


FUNCTION Get_Asset_Category_ID (
  asset_id_              IN NUMBER ) RETURN VARCHAR2;


FUNCTION Get_Asset_Category_Name (
  asset_id_              IN NUMBER ) RETURN VARCHAR2;


FUNCTION Get_Asset_Book_Type_Code (
  asset_id_              IN NUMBER ) RETURN VARCHAR2;


FUNCTION Get_Asset_Book_Type_Name (
  asset_id_              IN NUMBER ) RETURN VARCHAR2;


FUNCTION Get_Method_Name (
  method_code_      IN VARCHAR2,
  life_in_months_     IN NUMBER ) RETURN VARCHAR2;
  

FUNCTION Get_ProRate_Convention_Desc (
  prorate_convention_code_      IN VARCHAR2 ) RETURN VARCHAR2;


FUNCTION Get_Location_Segments (
  location_id_              IN NUMBER ) RETURN VARCHAR2;


FUNCTION Get_Adjusted_Recoverable_Cost (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2 ) RETURN NUMBER;


FUNCTION Get_Current_Cost (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2 ) RETURN NUMBER;


FUNCTION Get_Cost_As_of_Period (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2,
   period_counter_           IN NUMBER ) RETURN NUMBER;


FUNCTION Get_Cost2_As_of_Period (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2,
   period_counter_           IN NUMBER ) RETURN NUMBER;
   

FUNCTION Get_Asset_Entered_Period (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2 ) RETURN VARCHAR2;


FUNCTION Get_Asset_Effective_Period (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2 ) RETURN VARCHAR2;


FUNCTION Get_Asset_Fiscal_Year (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2 ) RETURN NUMBER;


FUNCTION Get_Project_Number (
  project_id_              IN NUMBER ) RETURN VARCHAR2;


FUNCTION Get_Task_Number (
  project_id_              IN NUMBER,
  task_id_                 IN NUMBER ) RETURN VARCHAR2;


FUNCTION Get_Retirement_Type_Name (
  retirement_type_code_      IN VARCHAR2 ) RETURN VARCHAR2;


FUNCTION Get_Retirement_Status_Name (
  status_              IN VARCHAR2 ) RETURN VARCHAR2;
  

FUNCTION Get_Max_Dist_ID_From_Depr_Det (
   asset_id_                  IN NUMBER,
   book_type_code_       IN VARCHAR2,   -- )  RETURN NUMBER
   period_counter_         IN NUMBER ) RETURN NUMBER;


FUNCTION Get_Dist_ID_From_Depr_Detail (
   asset_id_                  IN NUMBER,
   book_type_code_       IN VARCHAR2,
   period_counter_         IN NUMBER ) RETURN NUMBER;

FUNCTION Get_Full_GL_Segment_of_Dist (
   asset_id_                  IN NUMBER,
   book_type_code_       IN VARCHAR2,
   asset_trans_date_     IN DATE ) RETURN VARCHAR2;


FUNCTION Get_Full_Loc_Segment_of_Dist (
   asset_id_                  IN NUMBER,
   book_type_code_       IN VARCHAR2,
   asset_trans_date_     IN DATE ) RETURN VARCHAR2;


FUNCTION Get_CCID_For_Distribution_ID (
   distribution_id_                  IN NUMBER ) RETURN NUMBER;


FUNCTION Get_Asset_Balances ( 
   asset_id_                  IN NUMBER,
   book_type_code_      IN VARCHAR2,
   period_counter_       IN NUMBER DEFAULT 0,
   field_name_             IN VARCHAR2 ) RETURN NUMBER;


PROCEDURE Calc_BO_EBS_Total_For_Year (
   book_type_code_           IN  VARCHAR2,
   year_                            IN NUMBER  );


PROCEDURE Calc_BO_EBS_Tot_For_CatGrp (
   book_type_code_           IN  VARCHAR2,
   year_                            IN NUMBER  );
                
END;

/
CREATE OR REPLACE PACKAGE BODY         APPS_FA_UTIL_API AS


FUNCTION Get_ProRate_Calendar (
  prorate_date_              IN DATE ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT calendar_type
        FROM fa_calendar_periods
     WHERE prorate_date_ BETWEEN start_date AND end_date;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_ProRate_Calendar;


FUNCTION Get_Deprn_Calendar (
  deprn_start_date_              IN DATE ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT calendar_type
        FROM fa_calendar_periods
     WHERE deprn_start_date_ BETWEEN start_date AND end_date;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Deprn_Calendar;


-----Functions From Book Controls Table
FUNCTION Get_Book_Type_Name (
  book_type_code_              IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT book_type_name
        FROM fa_book_controls
     WHERE book_type_code = book_type_code_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Book_Type_Name;


FUNCTION Get_Book_Deprn_Calendar (
  book_type_code_              IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT deprn_calendar
        FROM fa_book_controls
     WHERE book_type_code = book_type_code_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Book_Deprn_Calendar;


FUNCTION Get_Book_ProRate_Calendar (
  book_type_code_              IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT prorate_calendar
        FROM fa_book_controls
     WHERE book_type_code = book_type_code_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Book_ProRate_Calendar;


FUNCTION Get_Deprn_Period_Name (
  book_type_code_              IN VARCHAR2,
  period_counter_                IN NUMBER  ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT period_name
        FROM FA_Deprn_Periods
     WHERE book_type_code = book_type_code_
           AND period_counter = period_counter_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Deprn_Period_Name;


FUNCTION Get_Deprn_Period_Counter (
  book_type_code_           IN VARCHAR2,
  period_name_                IN VARCHAR2  ) RETURN NUMBER
IS
   temp_    NUMBER;
   CURSOR get_attr_ IS
     SELECT period_counter
        FROM FA_Deprn_Periods
     WHERE book_type_code = book_type_code_
           AND period_name = period_name_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Deprn_Period_Counter;


FUNCTION Get_Deprn_Period_Name_By_Date (
  book_type_code_              IN VARCHAR2,
  trans_date_                     IN DATE  ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT period_name
        FROM FA_Deprn_Periods
     WHERE book_type_code = book_type_code_
           AND trans_date_ BETWEEN period_open_date AND nvl(period_close_date, sysdate);
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Deprn_Period_Name_By_Date;


FUNCTION Get_Deprn_Period_Cal_End_Date (
  book_type_code_           IN VARCHAR2,
  period_name_                IN VARCHAR2  ) RETURN DATE
IS
   temp_    DATE;
   CURSOR get_attr_ IS
     SELECT calendar_period_close_date
        FROM FA_Deprn_Periods
     WHERE book_type_code = book_type_code_
           AND period_name = period_name_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Deprn_Period_Cal_End_Date;


FUNCTION Get_Deprn_Period_Start_Date (
  book_type_code_           IN VARCHAR2,
  period_name_                IN VARCHAR2  ) RETURN DATE
IS
   temp_    DATE;
   CURSOR get_attr_ IS
     SELECT period_open_date
        FROM FA_Deprn_Periods
     WHERE book_type_code = book_type_code_
           AND period_name = period_name_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Deprn_Period_Start_Date;


FUNCTION Get_Deprn_Period_End_Date (
  book_type_code_           IN VARCHAR2,
  period_name_                IN VARCHAR2  ) RETURN DATE
IS
   temp_    DATE;
   CURSOR get_attr_ IS
     SELECT NVL(period_close_date,SYSDATE)
        FROM FA_Deprn_Periods
     WHERE book_type_code = book_type_code_
           AND period_name = period_name_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Deprn_Period_End_Date;


FUNCTION Get_Deprn_Period_Param (
  book_type_code_           IN VARCHAR2,
  period_name_                IN VARCHAR2,
  param_                         IN VARCHAR2  ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(25);
   dbk_      VARCHAR2(25);
   upc_     VARCHAR2(10);
   ucd_     VARCHAR2(25);
   tpc_     VARCHAR2(10);
   tod_     VARCHAR2(25);
   
   CURSOR get_attr_ IS
     SELECT bc.distribution_source_book dbk,
           To_Char(NVL (dp.period_close_date, SYSDATE),'DD/MM/YYYY HH:MI:SS AM') ucd,
           dp.period_counter upc,
           To_Char(MIN (dp_fy.period_open_date),'DD/MM/YYYY HH:MI:SS AM') tod,
           MIN (dp_fy.period_counter) tpc
      FROM fa_deprn_periods dp, fa_deprn_periods dp_fy, fa_book_controls bc
    WHERE dp.book_type_code = book_type_code_
         AND dp.period_name = period_name_
         AND dp_fy.book_type_code =  book_type_code_
        AND dp_fy.fiscal_year = dp.fiscal_year
        AND bc.book_type_code =  book_type_code_
   GROUP BY bc.distribution_source_book, dp.period_close_date, dp.period_counter;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO dbk_, ucd_, upc_, tod_, tpc_;
  CLOSE get_attr_;
  IF param_ = 'UCD' THEN
     temp_ := ucd_;   --To_Char(ucd_,'DD/MM/YYYY HH:MI:SS AM');
  ELSIF param_ = 'TOD' THEN
     temp_ := tod_;    --To_Char(tod_,'DD/MM/YYYY HH:MI:SS AM');
  ELSIF param_ = 'UPC' THEN
     temp_ := upc_;
  ELSIF param_ = 'TPC' THEN
     temp_ := tpc_;
  END IF;
  RETURN temp_;
END Get_Deprn_Period_Param;



-----Functions From FA CATEGORIES B
FUNCTION Get_Category_Segments (
  category_id_              IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT segment1||'-'||segment2
        FROM FA_Categories_B
     WHERE category_id = category_id_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Category_Segments;


FUNCTION Get_Category_Segment1 (
  category_id_              IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT segment1
        FROM FA_Categories_B
     WHERE category_id = category_id_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Category_Segment1;


FUNCTION Get_Category_Segment2 (
  category_id_              IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT segment2
        FROM FA_CATEGORIES_B
     WHERE category_id = category_id_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Category_Segment2;

-----Functions From FA_ADDITIONS
FUNCTION Get_Asset_Description (
  asset_id_              IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT description
        FROM FA_ADDITIONS_TL
     WHERE asset_id = asset_id_
          AND LANGUAGE = 'US';
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Asset_Description;


FUNCTION Get_Asset_Category_ID (
  asset_id_              IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT Asset_Category_ID
        FROM FA_ADDITIONS_B
     WHERE asset_id = asset_id_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Asset_Category_ID;


FUNCTION Get_Asset_Category_Name (
  asset_id_              IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
BEGIN
  temp_ := Get_Category_Segments(Get_Asset_Category_ID ( asset_id_ ));
  RETURN temp_;
END Get_Asset_Category_Name;


-----Functions From FA BOOKS
FUNCTION Get_Asset_Book_Type_Code (
  asset_id_              IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT book_type_code
        FROM FA_BOOKS
     WHERE asset_id = asset_id_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Asset_Book_Type_Code;



FUNCTION Get_Asset_Book_Type_Name (
  asset_id_              IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
BEGIN
  temp_ := Get_Book_Type_Name (  Get_Asset_Book_Type_Code ( asset_id_   )); 
  RETURN temp_;
END Get_Asset_Book_Type_Name;



FUNCTION Get_Method_Name (
  method_code_      IN VARCHAR2,
  life_in_months_     IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT name
        FROM FA_METHODS
     WHERE method_code = method_code_
          AND life_in_months = life_in_months_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Method_Name;


FUNCTION Get_ProRate_Convention_Desc (
  prorate_convention_code_      IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT description
        FROM FA_CONVENTION_TYPES
     WHERE prorate_convention_code = prorate_convention_code_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_ProRate_Convention_Desc;


-----Functions From FA CATEGORIES B
FUNCTION Get_Location_Segments (
  location_id_              IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT segment1||'-'||segment2||'-'||segment1||'-'||segment3||'-'||segment4||'-'||segment5||'-'||segment6
        FROM FA_Locations
     WHERE location_id = location_id_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Location_Segments;


FUNCTION Get_Adjusted_Recoverable_Cost (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2 ) RETURN NUMBER
IS
   temp_    NUMBER;
   CURSOR get_attr_ IS
    SELECT adjusted_recoverable_cost
       FROM fa_books
     WHERE book_type_code = book_type_code_
          AND asset_id       = asset_id_
          AND date_ineffective IS NULL;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN NVL(temp_,0);
END Get_Adjusted_Recoverable_Cost;


FUNCTION Get_Current_Cost (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2 ) RETURN NUMBER
IS
   temp_    NUMBER;
   CURSOR get_attr_ IS
    SELECT current_cost
       FROM fa_financial_inquiry_cost_v
     WHERE book_type_code = book_type_code_
          AND asset_id       = asset_id_
     ORDER BY transaction_header_id_in DESC;          
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN NVL(temp_,0);
END Get_Current_Cost;


FUNCTION Get_Cost_As_of_Period (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2,
   period_counter_           IN NUMBER ) RETURN NUMBER
IS
   temp_    NUMBER;
   CURSOR get_attr_ IS
    SELECT Decode(a.deprn_source_code,'B',a.addition_cost_to_clear, a.cost) cost_     ----adjusted_cost
       FROM fa_deprn_detail  a--fa_deprn_summary
     WHERE a.book_type_code = book_type_code_
          AND a.asset_id       = asset_id_
          --AND period_counter = period_counter_
          AND a.cost != 0
          AND a.period_counter =
          (SELECT MAX (dd_sub.period_counter)
             FROM fa_deprn_detail dd_sub
            WHERE dd_sub.book_type_code = book_type_code_
              AND dd_sub.asset_id = a.asset_id
              AND dd_sub.distribution_id = a.distribution_id
              AND dd_sub.period_counter <= period_counter_)
         ORDER BY distribution_id DESC;          
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN NVL(temp_,0);
END Get_Cost_As_of_Period;


FUNCTION Get_Cost2_As_of_Period (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2,
   period_counter_           IN NUMBER ) RETURN NUMBER
IS
   temp_      NUMBER;
   dbk_        VARCHAR2(25);
   upc_        NUMBER;
   ucd_        DATE;
   tpc_         NUMBER;
   tod_         DATE;

   CURSOR get_attr0_ IS   
     SELECT bc.distribution_source_book dbk,
         NVL (dp.period_close_date, SYSDATE) ucd,
         dp.period_counter upc,
         MIN (dp_fy.period_open_date) tod,
         MIN (dp_fy.period_counter) tpc
          FROM fa_deprn_periods dp, fa_deprn_periods dp_fy, fa_book_controls bc
        WHERE dp.book_type_code =  book_type_code_
            AND dp.period_name = Get_Deprn_Period_Name (  book_type_code_,  period_counter_)
            AND dp_fy.book_type_code = book_type_code_
            AND dp_fy.fiscal_year = dp.fiscal_year
            AND bc.book_type_code =  book_type_code_
        GROUP BY bc.distribution_source_book, dp.period_close_date, dp.period_counter;
   
   CURSOR get_attr_ IS
    SELECT Sum(x.cost) cost FROM
     (SELECT dd_bonus.cost cost
      FROM fa_deprn_detail dd_bonus,
                fa_asset_history ah,
                fa_transaction_headers th,
                fa_transaction_headers th_rt,
                fa_books books,
                fa_distribution_history dh,
                fa_category_books cb
    WHERE cb.book_type_code = book_type_code_
         AND cb.category_id = ah.category_id
         AND ah.asset_id = dh.asset_id
         AND ah.date_effective < NVL (th.date_effective, ucd_)
         AND NVL (ah.date_ineffective, SYSDATE) >= NVL (th.date_effective, ucd_)
         AND --  AH.ASSET_TYPE                   = 'CAPITALIZED'
            --AND
            dd_bonus.book_type_code = book_type_code_
         AND dd_bonus.distribution_id = dh.distribution_id
         AND dd_bonus.period_counter =
          (SELECT MAX (dd_sub.period_counter)
             FROM fa_deprn_detail dd_sub
            WHERE dd_sub.book_type_code = book_type_code_
              AND dd_sub.asset_id = dh.asset_id
              AND dd_sub.distribution_id = dh.distribution_id
              AND dd_sub.period_counter <= upc_)
         AND th_rt.book_type_code = book_type_code_
         AND th_rt.transaction_header_id = books.transaction_header_id_in
         AND books.book_type_code = book_type_code_
         AND books.asset_id = dh.asset_id
         AND NVL (books.period_counter_fully_retired, upc_) >= tpc_
         AND books.date_effective <= NVL (th.date_effective, ucd_)
         AND NVL (books.date_ineffective, SYSDATE + 1) > NVL (th.date_effective, ucd_)
         AND th.book_type_code(+) = book_type_code_
         AND th.transaction_header_id(+) = dh.transaction_header_id_out
         AND th.date_effective(+) BETWEEN tod_ AND ucd_
         AND dh.book_type_code = book_type_code_
         AND dh.date_effective <= ucd_
         AND NVL (dh.date_ineffective, SYSDATE) > tod_
         AND dh.asset_id = asset_id_
     UNION ALL
        SELECT 
            0 cost
        FROM fa_deprn_detail dd,
                fa_asset_history ah,
                fa_transaction_headers th,
                fa_transaction_headers th_rt,
                fa_books books,
                fa_distribution_history dh,
                fa_category_books cb
       WHERE cb.book_type_code = book_type_code_
            AND cb.category_id = ah.category_id
            AND ah.asset_id = dh.asset_id
            AND ah.date_effective < NVL (th.date_effective, ucd_)
            AND NVL (ah.date_ineffective, SYSDATE) >= NVL (th.date_effective, ucd_)
            AND --AH.ASSET_TYPE                   = 'CAPITALIZED'
            --AND
            dd.book_type_code = book_type_code_
            AND dd.distribution_id = dh.distribution_id
            AND dd.period_counter =
                (SELECT MAX (dd_sub.period_counter)
                    FROM fa_deprn_detail dd_sub
                    WHERE dd_sub.book_type_code = book_type_code_
                        AND dd_sub.asset_id = dh.asset_id
                        AND dd_sub.distribution_id = dh.distribution_id
                        AND dd_sub.period_counter <= upc_)
            AND th_rt.book_type_code = book_type_code_
            AND th_rt.transaction_header_id = books.transaction_header_id_in
            AND books.book_type_code = book_type_code_
            AND books.asset_id = dh.asset_id
            AND NVL (books.period_counter_fully_retired, upc_) >= tpc_
            AND books.date_effective <= NVL (th.date_effective, ucd_)
            AND NVL (books.date_ineffective, SYSDATE + 1) > NVL (th.date_effective, ucd_)
            AND books.bonus_rule IS NOT NULL
            AND th.book_type_code(+) = book_type_code_
            AND th.transaction_header_id(+) = dh.transaction_header_id_out
            AND th.date_effective(+) BETWEEN tod_ AND ucd_
            AND dh.book_type_code = book_type_code_
            AND dh.date_effective <= ucd_
            AND NVL (dh.date_ineffective, SYSDATE) > tod_
            AND dh.asset_id = asset_id_ ) x
          WHERE x.cost <> 0;  
BEGIN
  OPEN get_attr0_;
  FETCH get_attr0_ INTO dbk_, ucd_, upc_, tod_, tpc_;  
  CLOSE get_attr0_;


  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN NVL(temp_,0);
END Get_Cost2_As_of_Period;


FUNCTION Get_Asset_Entered_Period (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(40);
   CURSOR get_attr_ IS
    SELECT period_entered
       FROM fa_financial_inquiry_cost_v
     WHERE book_type_code = book_type_code_
          AND asset_id       = asset_id_
          AND transaction_type IN ( 'Addition','CIP Addition','Addition/Void')
     ORDER BY transaction_header_id_in DESC;          
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN NVL(temp_,0);
END Get_Asset_Entered_Period;


FUNCTION Get_Asset_Effective_Period (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(40);
   CURSOR get_attr_ IS
    SELECT period_effective
       FROM fa_financial_inquiry_cost_v
     WHERE book_type_code = book_type_code_
          AND asset_id       = asset_id_
          AND transaction_type  IN ( 'Addition','CIP Addition','Addition/Void')
     ORDER BY transaction_header_id_in DESC;          
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN NVL(temp_,0);
END Get_Asset_Effective_Period;


FUNCTION Get_Asset_Fiscal_Year (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2 ) RETURN NUMBER
IS
   temp_    NUMBER;
   CURSOR get_attr_ IS
    SELECT fiscal_year
       FROM fa_financial_inquiry_cost_v
     WHERE book_type_code = book_type_code_
          AND asset_id       = asset_id_
     ORDER BY transaction_header_id_in DESC;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN NVL(temp_,0);
END Get_Asset_Fiscal_Year;


FUNCTION Get_Asset_Entered_Year_Period (
   asset_id_                    IN NUMBER,
   book_type_code_        IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(40);
   CURSOR get_attr_ IS
    SELECT To_Char(transaction_date_entered,'YYYY')||'-'||To_Char(transaction_date_entered,'MM')
       FROM fa_financial_inquiry_cost_v
     WHERE book_type_code = book_type_code_
          AND asset_id       = asset_id_
     ORDER BY transaction_header_id_in DESC;          
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN NVL(temp_,0);
END Get_Asset_Entered_Year_Period;


FUNCTION Get_Project_Number (
  project_id_              IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT distinct segment1
        FROM pa_projects_all
     WHERE project_id = project_id_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Project_Number;


FUNCTION Get_Task_Number (
  project_id_              IN NUMBER,
  task_id_                 IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT distinct task_number
        FROM pa_tasks_all_v
     WHERE project_id = project_id_
          AND task_id = task_id_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Task_Number;


FUNCTION Get_Retirement_Type_Name (
  retirement_type_code_      IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
    SELECT meaning
       FROM fa_lookups
    WHERE lookup_type = 'RETIREMENT'
         AND lookup_code = retirement_type_code_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Retirement_Type_Name;


FUNCTION Get_Retirement_Status_Name (
  status_              IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
    SELECT meaning
       FROM fa_lookups
    WHERE lookup_type = 'RETIREMENT STATUS'
         AND lookup_code = status_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Retirement_Status_Name;


FUNCTION Get_Max_Dist_ID_From_Depr_Det (
   asset_id_                  IN NUMBER,
   book_type_code_       IN VARCHAR2,   -- )  RETURN NUMBER
   period_counter_         IN NUMBER ) RETURN NUMBER
IS
   temp_    NUMBER;
   CURSOR get_attr_ IS
    SELECT distribution_id
       FROM fa_deprn_detail
     WHERE asset_id = asset_id_
          AND book_type_code = book_type_code_
          AND period_counter = (SELECT MAX(period_counter)
                                               FROM fa_deprn_detail
                                            WHERE asset_id = asset_id_
                                                  AND book_type_code = book_type_code_
                                                  AND period_counter <= period_counter_ );  
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Max_Dist_ID_From_Depr_Det;


FUNCTION Get_Dist_ID_From_Depr_Detail (
   asset_id_                  IN NUMBER,
   book_type_code_       IN VARCHAR2,
   period_counter_         IN NUMBER ) RETURN NUMBER
IS
   temp_    NUMBER;
   CURSOR get_attr_ IS
    SELECT distribution_id
       FROM fa_deprn_detail
     WHERE asset_id = asset_id_
          AND book_type_code = book_type_code_
          AND period_counter = period_counter_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  IF temp_ IS NULL THEN
     /*--BEGIN
       SELECT distribution_id
          INTO temp_
         FROM fa_deprn_detail
       WHERE asset_id = asset_id_
            AND book_type_code = book_type_code_
            AND period_counter = (SELECT MAX(period_counter)
                                               FROM fa_deprn_detail
                                            WHERE asset_id = asset_id_
                                                  AND book_type_code = book_type_code_ 
                                                  AND period_counter <= period_counter_)
            and rownum = 1;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         temp_ := null;                                             
     END;--*/                                           
     temp_ := Get_Max_Dist_ID_From_Depr_Det ( asset_id_,  book_type_code_, period_counter_ );
  END IF;
  RETURN temp_;
END Get_Dist_ID_From_Depr_Detail;



FUNCTION Get_Full_GL_Segment_of_Dist (
   asset_id_                  IN NUMBER,
   book_type_code_       IN VARCHAR2,
   asset_trans_date_     IN DATE ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
    SELECT APPS_GL_CODE_COMB_UTIL_API.Get_Full_Segment (code_combination_id) Full_GL_Segment
       FROM fa_distribution_history
     WHERE asset_id = asset_id_
          AND book_type_code = book_type_code_
          AND asset_trans_date_  BETWEEN  date_effective  AND NVL(date_ineffective,SYSDATE);  
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Full_GL_Segment_of_Dist;


FUNCTION Get_Full_Loc_Segment_of_Dist (
   asset_id_                  IN NUMBER,
   book_type_code_       IN VARCHAR2,
   asset_trans_date_     IN DATE ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
    SELECT Get_Location_Segments (location_id) Full_Location_Segment
       FROM fa_distribution_history
     WHERE asset_id = asset_id_
          AND book_type_code = book_type_code_
          AND asset_trans_date_  BETWEEN  date_effective  AND NVL(date_ineffective,SYSDATE);  
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Full_Loc_Segment_of_Dist;


FUNCTION Get_CCID_For_Distribution_ID (
   distribution_id_                  IN NUMBER ) RETURN NUMBER
IS
   temp_    NUMBER;
   CURSOR get_attr_ IS
    SELECT code_combination_id
       FROM fa_distribution_history
     WHERE distribution_id = distribution_id_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_CCID_For_Distribution_ID;



FUNCTION Get_Asset_Balances ( 
   asset_id_                  IN NUMBER,
   book_type_code_      IN VARCHAR2,
   period_counter_       IN NUMBER DEFAULT 0,
   field_name_             IN VARCHAR2 ) RETURN NUMBER
IS
   dummy_num                       NUMBER;
   dummy_char                       VARCHAR2 (10);
   dummy_bool                       BOOLEAN;
   v_num_per_fiscal_year        NUMBER;
   v_num_per_fiscal_year_prorate   NUMBER;                                                                            -- Bug#6151598
   initial_pc                           NUMBER;
   initial_cpod                       DATE;
   initial_cpcd                       DATE;
   diff                                   NUMBER;
   l_prorate_date                   DATE;
   l_min_cpod                       DATE;
   l_impairment_rsv               NUMBER;                                                                             --Bug#7293626
   v_depr_when_acquired_flag       VARCHAR2 (3);
   
   cost_                             NUMBER;
   net_book_value_             NUMBER;
   deprn_reserve_               NUMBER;
   reval_reserve_                NUMBER;
   ytd_deprn_                    NUMBER;
   ytd_production_             NUMBER;
   ltd_production_              NUMBER;
   bonus_deprn_reserve_    NUMBER;
   bonus_ytd_deprn_          NUMBER;
   l_impairment_rsv_          NUMBER;
   ytd_impairment_            NUMBER;
   field_value_                   NUMBER;
   deprn_exp_                   NUMBER; 

BEGIN
   --Populate deprn data using OFA_QUERY_FIN_INFO user-exit
   --    user_exit('OFA QUERY_FIN_INFO ' ||
   --              'ASSET_ID="asset_id" '             ||
   --              'BOOK="' || book_type_code || '" ' ||
   --              'DEPRN_RSV="deprn_reserve" '       ||
   --              'REVAL_RSV="reval_reserve" '       ||
   --              'YTD_DEPRN="ytd_deprn" '           ||
   --              'YTD_PROD="ytd_production" '       ||
   --              'LTD_PROD="ltd_production"' );

   ---IF to prevent being called twice for NBV field
      fa_query_balances_pkg.query_balances (
            x_asset_id                => asset_id_,
            x_book                      => book_type_code_,
            x_period_ctr               => period_counter_,
            x_dist_id                   => 0,
            x_run_mode              => 'STANDARD',
            x_cost                      => cost_,                  --Asset Cost
            x_deprn_rsv               => deprn_reserve_,   -- Accumulated depreciation
            x_reval_rsv                 => reval_reserve_,    --REVALUATION RESERVE
            x_ytd_deprn               => ytd_deprn_,         --YTD depreciation
            x_ytd_reval_exp         => dummy_num,
            x_reval_deprn_exp      => dummy_num,
            x_deprn_exp               => deprn_exp_,
            x_reval_amo               => dummy_num,
            x_prod                       => dummy_num,
            x_ytd_prod                 => ytd_production_,    --YTD Production
            x_ltd_prod                  => ltd_production_,        --LTD Production
            x_adj_cost                 => dummy_num,         --
            x_reval_amo_basis     => dummy_num,
            x_bonus_rate              => dummy_num,
            x_deprn_source_code  => dummy_char,
            x_adjusted_flag           => dummy_bool,
            x_transaction_header_id   => -1,
            x_bonus_deprn_rsv         => bonus_deprn_reserve_,    --LTD BONUS DEPRN
            x_bonus_ytd_deprn         => bonus_ytd_deprn_,         --YTD BONUS DEPRN
            x_bonus_deprn_amount      => dummy_num,
            x_impairment_rsv          => l_impairment_rsv_,                                --Bug#7293626
            x_ytd_impairment          => ytd_impairment_,                          --phase5
            x_impairment_amount       => dummy_num,
            -- RER12
            x_capital_adjustment      => dummy_num,
            x_general_fund            => dummy_num,
            x_mrc_sob_type_code       => 'P',
            x_set_of_books_id         => NULL,
            p_log_level_rec           => NULL  -- End RER12
            );
           
   --Populate net_book_value using deprn_reserve returned from QUERY_FIN_INFO
   --Bug#7293626 -to calculate net_book_value subtract imapairment reserve as well
     cost_ := Apps_FA_Util_Api.Get_Cost2_As_of_Period ( asset_id_,   book_type_code_, period_counter_ );
     IF cost_ = 0 THEN cost_ := Get_Current_Cost (   asset_id_ ,   book_type_code_ );  END IF;
     net_book_value_ := (cost_ - deprn_reserve_ - NVL (l_impairment_rsv_, 0));

   field_value_ := 0;
   IF field_name_ = 'COST'  THEN
         field_value_ :=  cost_;
   ELSIF field_name_ = 'NET BOOK VALUE'  THEN
         field_value_ :=  net_book_value_;
   ELSIF field_name_ = 'DEPRN AMT'  THEN
            field_value_ :=  deprn_exp_;
   ELSIF field_name_ = 'ACCUM DEPRN'  THEN
            field_value_ :=  deprn_reserve_;
   ELSIF field_name_ = 'YTD DEPRN'  THEN
         field_value_ :=  ytd_deprn_;
   ELSIF field_name_ = 'YTD PRODUCTION'  THEN
         field_value_ :=  ytd_production_;
   ELSIF field_name_ = 'LTD PRODUCTION'  THEN
         field_value_ :=  ltd_production_;
   ELSIF field_name_ = 'REVALUATION RESERVE'  THEN
         field_value_ :=  reval_reserve_;
   ELSIF field_name_ = 'YTD BONUS DEPRN'  THEN
         field_value_ :=  bonus_ytd_deprn_;
   ELSIF field_name_ = 'LTD BONUS DEPRN'  THEN
         field_value_ :=  bonus_deprn_reserve_;
   END IF;       
   
  RETURN field_value_; 
END Get_Asset_Balances;



PROCEDURE Calc_BO_EBS_Total_For_Year (
   book_type_code_           IN  VARCHAR2,
   year_                            IN NUMBER  )
IS
   temp_    VARCHAR2(25);
   dbk_      VARCHAR2(25);
   upc_     NUMBER;
   ucd_     DATE;
   tpc_     NUMBER;
   tod_     DATE;
   period_name_ VARCHAR2(10);

   CURSOR c1 IS
     SELECT DISTINCT dp.period_name
      FROM fa_deprn_periods dp
    WHERE dp.book_type_code = book_type_code_
        AND  dp.fiscal_year = year_
      ORDER BY dp.fiscal_year, dp.period_num;
  
   CURSOR get_attr_ (period_name__ IN VARCHAR2 )
    IS
     SELECT bc.distribution_source_book dbk,
           NVL (dp.period_close_date, SYSDATE) ucd,
           dp.period_counter upc,
           MIN (dp_fy.period_open_date) tod,
           MIN (dp_fy.period_counter) tpc
      FROM fa_deprn_periods dp, fa_deprn_periods dp_fy, fa_book_controls bc
    WHERE dp.book_type_code = book_type_code_
         AND dp.period_name = period_name__
         AND dp_fy.book_type_code =  book_type_code_
        AND dp_fy.fiscal_year = dp.fiscal_year
        AND bc.book_type_code =  book_type_code_
   GROUP BY bc.distribution_source_book, dp.period_close_date, dp.period_counter;
BEGIN
 FOR d1 IN c1 LOOP 
   period_name_ := d1.period_name;   
   
   dbk_ := NULL;  ucd_ := NULL;  upc_ := NULL;  tod_ := NULL;  tpc_ := NULL;
   OPEN get_attr_ (period_name_) ;
   FETCH get_attr_ INTO dbk_, ucd_, upc_, tod_, tpc_;
   CLOSE get_attr_;

   INSERT INTO SAV_FA_BO_RECONCILE ( period_name, system_name, cost, deprn_amount, deprn_reserve, ytd_deprn, nbv, book_type_code ) 
   SELECT  period_name_  Period_Name,  'EBS' system_, Sum(x.cost) cost_, Sum(x.deprn_amount) deprn_amount, Sum(x.deprn_reserve) Deprn_reserve, Sum(x.ytd_deprn) ytd_deprn, (Sum(x.cost) - Sum(x.deprn_reserve)) Nbv,  book_type_code_ 
      FROM
     (SELECT dh.asset_id asset_id,
       dh.code_combination_id dh_ccid,
       APPS_GL_CODE_COMB_UTIL_API.Get_Segment2(dh.code_combination_id) segment2,
       cb.deprn_reserve_acct rsv_account,
       books.date_placed_in_service start_date,
       books.deprn_method_code method,
       books.life_in_months life,
       books.adjusted_rate rate,
       books.production_capacity capacity,
       dd_bonus.cost cost,
       DECODE (dd_bonus.period_counter, upc_, dd_bonus.deprn_amount - dd_bonus.bonus_deprn_amount, 0) deprn_amount,
       DECODE (SIGN (tpc_ - dd_bonus.period_counter), 1, 0, dd_bonus.ytd_deprn - dd_bonus.bonus_ytd_deprn) ytd_deprn,
       dd_bonus.deprn_reserve - dd_bonus.bonus_deprn_reserve deprn_reserve,
       DECODE (th.transaction_type_code, NULL, dh.units_assigned / ah.units * 100) percent,
       DECODE (th.transaction_type_code,
               NULL, DECODE (th_rt.transaction_type_code, 'FULL RETIREMENT', 'F', DECODE (books.depreciate_flag, 'NO', 'N')),
               'TRANSFER', 'T',
               'TRANSFER OUT', 'P',
               'RECLASS', 'R')
          t_type,
       dd_bonus.period_counter,
       NVL (th.date_effective, ucd_),
       ''
    FROM fa_deprn_detail dd_bonus,
              fa_asset_history ah,
              fa_transaction_headers th,
              fa_transaction_headers th_rt,
              fa_books books,
              fa_distribution_history dh,
              fa_category_books cb
     WHERE cb.book_type_code = book_type_code_
         AND cb.category_id = ah.category_id
         AND ah.asset_id = dh.asset_id
         AND ah.date_effective < NVL (th.date_effective, ucd_)
         AND NVL (ah.date_ineffective, SYSDATE) >= NVL (th.date_effective, ucd_)
         AND --  AH.ASSET_TYPE                   = 'CAPITALIZED'
              dd_bonus.book_type_code = book_type_code_
         AND dd_bonus.distribution_id = dh.distribution_id
         AND dd_bonus.period_counter =
          (SELECT MAX (dd_sub.period_counter)
             FROM fa_deprn_detail dd_sub
            WHERE dd_sub.book_type_code = book_type_code_
              AND dd_sub.asset_id = dh.asset_id
              AND dd_sub.distribution_id = dh.distribution_id
              AND dd_sub.period_counter <= upc_)
        AND th_rt.book_type_code = book_type_code_
        AND th_rt.transaction_header_id = books.transaction_header_id_in
        AND books.book_type_code = book_type_code_
        AND books.asset_id = dh.asset_id
        AND NVL (books.period_counter_fully_retired, upc_) >= tpc_
        AND books.date_effective <= NVL (th.date_effective, ucd_)
        AND NVL (books.date_ineffective, SYSDATE + 1) > NVL (th.date_effective, ucd_)
        AND th.book_type_code(+) = book_type_code_
        AND th.transaction_header_id(+) = dh.transaction_header_id_out
        AND th.date_effective(+) BETWEEN tod_ AND ucd_
        AND dh.book_type_code = book_type_code_
        AND dh.date_effective <= ucd_
        AND NVL (dh.date_ineffective, SYSDATE) > tod_
    UNION ALL
    SELECT dh.asset_id asset_id,
       dh.code_combination_id dh_ccid,
       APPS_GL_CODE_COMB_UTIL_API.Get_Segment2(dh.code_combination_id) segment2,       
       cb.bonus_deprn_reserve_acct rsv_account,
       books.date_placed_in_service start_date,
       books.deprn_method_code method,
       books.life_in_months life,
       books.adjusted_rate rate,
       books.production_capacity capacity,
       0 cost,
       DECODE (dd.period_counter, upc_, dd.bonus_deprn_amount, 0) deprn_amount,
       DECODE (SIGN (tpc_ - dd.period_counter), 1, 0, dd.bonus_ytd_deprn) ytd_deprn,
       dd.bonus_deprn_reserve deprn_reserve,
       0 percent,
       'B' t_type,
       dd.period_counter,
       NVL (th.date_effective, ucd_),
       cb.bonus_deprn_expense_acct
    FROM fa_deprn_detail dd,
            fa_asset_history ah,
            fa_transaction_headers th,
            fa_transaction_headers th_rt,
            fa_books books,
            fa_distribution_history dh,
            fa_category_books cb
    WHERE cb.book_type_code = book_type_code_
         AND cb.category_id = ah.category_id
         AND ah.asset_id = dh.asset_id
         AND ah.date_effective < NVL (th.date_effective, ucd_)
         AND NVL (ah.date_ineffective, SYSDATE) >= NVL (th.date_effective, ucd_)
         AND --AH.ASSET_TYPE                   = 'CAPITALIZED'
               dd.book_type_code = book_type_code_
        AND dd.distribution_id = dh.distribution_id
        AND dd.period_counter =
          (SELECT MAX (dd_sub.period_counter)
             FROM fa_deprn_detail dd_sub
            WHERE dd_sub.book_type_code = book_type_code_
              AND dd_sub.asset_id = dh.asset_id
              AND dd_sub.distribution_id = dh.distribution_id
              AND dd_sub.period_counter <= upc_)
        AND th_rt.book_type_code = book_type_code_
        AND th_rt.transaction_header_id = books.transaction_header_id_in
        AND books.book_type_code = book_type_code_
        AND books.asset_id = dh.asset_id
        AND NVL (books.period_counter_fully_retired, upc_) >= tpc_
        AND books.date_effective <= NVL (th.date_effective, ucd_)
        AND NVL (books.date_ineffective, SYSDATE + 1) > NVL (th.date_effective, ucd_)
        AND books.bonus_rule IS NOT NULL
        AND th.book_type_code(+) = book_type_code_
        AND th.transaction_header_id(+) = dh.transaction_header_id_out
        AND th.date_effective(+) BETWEEN tod_ AND ucd_
        AND dh.book_type_code = book_type_code_
        AND dh.date_effective <= ucd_
        AND NVL (dh.date_ineffective, SYSDATE) > tod_
        )   x
        -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    UNION
        SELECT period_name_ Period_Name,  'BO' system_, Sum(cost) cost_, Sum(deprn_amount) deprn_amount,  Sum(deprn_reserve) Deprn_reserve, Sum(ytd_deprn) ytd_deprn, (Sum(cost) - Sum(deprn_reserve)) Nbv, book_type_code_
           FROM
        (SELECT apps_appl.fa_additions_b.asset_id,
            DECODE (apps_appl.fa_deprn_detail.deprn_source_code, 'B', apps_appl.fa_deprn_detail.addition_cost_to_clear, apps_appl.fa_deprn_detail.cost) cost,
            DECODE (apps_appl.fa_deprn_detail.period_counter,TO_NUMBER (LTRIM (RTRIM (apps_fa_util_api.get_deprn_period_param (apps_appl.fa_distribution_history.book_type_code, period_name_, 'UPC')))),   
                apps_appl.fa_deprn_detail.deprn_amount - apps_appl.fa_deprn_detail.bonus_deprn_amount,  0)   deprn_amount,
            apps_appl.fa_deprn_detail.deprn_reserve - NVL (apps_appl.fa_deprn_detail.bonus_deprn_amount, 0) deprn_reserve,
            DECODE (SIGN (  To_NUMBER(Ltrim(Rtrim(Apps_FA_Util_API.Get_Deprn_Period_Param (APPS_APPL.FA_DISTRIBUTION_HISTORY.book_type_code, 
                 period_name_, 'TPC')))) - APPS_APPL.FA_DEPRN_DETAIL.period_counter), 1, 0, APPS_APPL.FA_DEPRN_DETAIL.ytd_deprn - APPS_APPL.FA_DEPRN_DETAIL.bonus_ytd_deprn) ytd_deprn
            FROM apps_appl.fa_category_books,
                      apps_appl.fa_additions_b,
                      apps_appl.fa_deprn_detail,
                      apps_appl.fa_distribution_history,
                      apps_appl.fa_books,
                      apps_appl.fa_asset_history,
                      apps_appl.fa_deprn_summary
         WHERE (apps_appl.fa_asset_history.asset_id = apps_appl.fa_additions_b.asset_id)
              AND (apps_appl.fa_additions_b.asset_id = apps_appl.fa_books.asset_id)
              AND (apps_appl.fa_books.book_type_code = apps_appl.fa_deprn_summary.book_type_code
              AND apps_appl.fa_books.asset_id = apps_appl.fa_deprn_summary.asset_id)
              AND (apps_appl.fa_category_books.category_id = apps_appl.fa_asset_history.category_id
              AND apps_appl.fa_category_books.book_type_code =   apps_fa_util_api.get_asset_book_type_code (apps_appl.fa_asset_history.asset_id) )
              AND (apps_appl.fa_deprn_summary.book_type_code = apps_appl.fa_deprn_detail.book_type_code
              AND apps_appl.fa_deprn_summary.asset_id = apps_appl.fa_deprn_detail.asset_id
              AND apps_appl.fa_deprn_summary.period_counter = apps_appl.fa_deprn_detail.period_counter)
              AND (apps_appl.fa_deprn_detail.book_type_code = apps_appl.fa_distribution_history.book_type_code
              AND apps_appl.fa_deprn_detail.distribution_id = apps_appl.fa_distribution_history.distribution_id)
              AND (apps_appl.fa_books.book_type_code = book_type_code_
              AND (apps_fa_util_api.get_deprn_period_counter (
                apps_appl.fa_books.book_type_code,
                apps_fa_util_api.get_asset_entered_period (apps_appl.fa_books.asset_id, apps_appl.fa_books.book_type_code)) <=
                apps_fa_util_api.get_deprn_period_counter (apps_appl.fa_books.book_type_code, period_name_))
             AND (apps_fa_util_api.get_deprn_period_end_date (apps_appl.fa_books.book_type_code, period_name_) BETWEEN apps_appl.fa_books.date_effective
                                                                                                          AND NVL ( apps_appl.fa_books.date_ineffective, SYSDATE + 1))
            AND ( (apps_fa_util_api.get_deprn_period_end_date (apps_appl.fa_distribution_history.book_type_code, period_name_) BETWEEN apps_appl.fa_distribution_history.date_effective
                                                                                                                           AND NVL ( apps_appl.fa_distribution_history.date_ineffective, SYSDATE + 1)
                OR (apps_fa_util_api.get_deprn_period_start_date (apps_appl.fa_distribution_history.book_type_code, period_name_) BETWEEN apps_appl.fa_distribution_history.date_effective
                                                                                                                              AND apps_appl.fa_distribution_history.date_ineffective
                        AND apps_appl.fa_distribution_history.date_ineffective IS NOT NULL)))
            AND (apps_appl.fa_deprn_detail.distribution_id = apps_appl.fa_distribution_history.distribution_id
            AND apps_appl.fa_deprn_detail.period_counter =
                (SELECT MAX (dd_sub.period_counter)
                    FROM apps_appl.fa_deprn_detail dd_sub
                 WHERE dd_sub.book_type_code = apps_appl.fa_distribution_history.book_type_code
                      AND dd_sub.asset_id = apps_appl.fa_distribution_history.asset_id
                      AND dd_sub.distribution_id = apps_appl.fa_distribution_history.distribution_id
                      AND dd_sub.period_counter <=
                        TO_NUMBER ( LTRIM ( RTRIM ( apps_fa_util_api.get_deprn_period_param (apps_appl.fa_distribution_history.book_type_code, period_name_, 'UPC'))))  )  )
                      AND (apps_fa_util_api.get_deprn_period_end_date (
                                apps_fa_util_api.get_asset_book_type_code (apps_appl.fa_asset_history.asset_id), period_name_) BETWEEN apps_appl.fa_asset_history.date_effective
                              AND NVL (apps_appl.fa_asset_history.date_ineffective, SYSDATE + 1))
                        AND (NVL (
                            apps_appl.fa_books.period_counter_fully_retired,
                            TO_NUMBER (LTRIM ( RTRIM ( apps_fa_util_api.get_deprn_period_param (apps_appl.fa_distribution_history.book_type_code, period_name_, 'UPC'))))) >=
                            TO_NUMBER ( LTRIM ( RTRIM ( apps_fa_util_api.get_deprn_period_param (apps_appl.fa_distribution_history.book_type_code, period_name_, 'TPC')))))
                    AND (apps_appl.fa_books.book_type_code IN (SELECT sav_fa_book_access.book_type_code
                                                 FROM sav_fa_book_access
                                                WHERE sav_fa_book_access.user_id = (SELECT UPPER ('ibaig') FROM DUAL))))
             ) y;
  END LOOP;
  Commit;
 
END Calc_BO_EBS_Total_For_Year;



PROCEDURE Calc_BO_EBS_Tot_For_CatGrp (
   book_type_code_           IN  VARCHAR2,
   year_                            IN NUMBER  )
IS
   temp_    VARCHAR2(25);
   dbk_      VARCHAR2(25);
   upc_     NUMBER;
   ucd_     DATE;
   tpc_     NUMBER;
   tod_     DATE;
   period_name_ VARCHAR2(10);
   period_num_ NUMBER;

   CURSOR c1 IS
     SELECT DISTINCT dp.period_name
      FROM fa_deprn_periods dp
    WHERE dp.book_type_code = book_type_code_
        AND  dp.fiscal_year = year_
      ORDER BY dp.fiscal_year, dp.period_num;
  
   CURSOR get_attr_ (period_name__ IN VARCHAR2 )
    IS
     SELECT bc.distribution_source_book dbk,
           NVL (dp.period_close_date, SYSDATE) ucd,
           dp.period_counter upc,
           MIN (dp_fy.period_open_date) tod,
           MIN (dp_fy.period_counter) tpc,
           dp.period_num
      FROM fa_deprn_periods dp, fa_deprn_periods dp_fy, fa_book_controls bc
    WHERE dp.book_type_code = book_type_code_
         AND dp.period_name = period_name__
         AND dp_fy.book_type_code =  book_type_code_
        AND dp_fy.fiscal_year = dp.fiscal_year
        AND bc.book_type_code =  book_type_code_
   GROUP BY bc.distribution_source_book, dp.period_close_date, dp.period_counter, dp.period_num;
BEGIN
 FOR d1 IN c1 LOOP 
   period_name_ := d1.period_name;   
   
   dbk_ := NULL;  ucd_ := NULL;  upc_ := NULL;  tod_ := NULL;  tpc_ := NULL; period_num_ := NULL;
   OPEN get_attr_ (period_name_) ;
   FETCH get_attr_  INTO  dbk_, ucd_, upc_, tod_, tpc_, period_num_;
   CLOSE get_attr_;

   INSERT INTO SAV_FA_BO_RECONCILE_BY_CAT ( year, period_num, period_name, system_name, category_segment1, category_segment2, cost, deprn_amount, deprn_reserve, ytd_deprn, nbv, book_type_code ) 
   SELECT  year_,  period_num_, period_name_  Period_Name,  'EBS' system_, Category_Segment1,  Category_Segment2, Sum(x.cost) cost_, Sum(x.deprn_amount) deprn_amount, Sum(x.deprn_reserve) Deprn_reserve, Sum(x.ytd_deprn) ytd_deprn, (Sum(x.cost) - Sum(x.deprn_reserve)) Nbv,  book_type_code_
      FROM
     (SELECT dh.asset_id asset_id,
       dh.code_combination_id dh_ccid,
       --APPS_GL_CODE_COMB_UTIL_API.Get_Segment2(dh.code_combination_id) segment2,
       cb.deprn_reserve_acct rsv_account,
       books.date_placed_in_service start_date,
       books.deprn_method_code method,
       books.life_in_months life,
       books.adjusted_rate rate,
       books.production_capacity capacity,
       dd_bonus.cost cost,
       DECODE (dd_bonus.period_counter, upc_, dd_bonus.deprn_amount - dd_bonus.bonus_deprn_amount, 0) deprn_amount,
       DECODE (SIGN (tpc_ - dd_bonus.period_counter), 1, 0, dd_bonus.ytd_deprn - dd_bonus.bonus_ytd_deprn) ytd_deprn,
       dd_bonus.deprn_reserve - dd_bonus.bonus_deprn_reserve deprn_reserve,
       DECODE (th.transaction_type_code, NULL, dh.units_assigned / ah.units * 100) percent,
       DECODE (th.transaction_type_code,
               NULL, DECODE (th_rt.transaction_type_code, 'FULL RETIREMENT', 'F', DECODE (books.depreciate_flag, 'NO', 'N')),
               'TRANSFER', 'T',
               'TRANSFER OUT', 'P',
               'RECLASS', 'R')
          t_type,
       dd_bonus.period_counter,
       NVL (th.date_effective, ucd_),
       '',
       --To_Char(NVL (th.date_effective, ucd_),'YYYY') year_,
       --To_Char(NVL (th.date_effective, ucd_),'MM') period_,
       Apps_FA_Util_API.Get_Category_Segment1( ah.category_id) Category_Segment1,
       Apps_FA_Util_API.Get_Category_Segment2( ah.category_id) Category_Segment2
    FROM fa_deprn_detail dd_bonus,
              fa_asset_history ah,
              fa_transaction_headers th,
              fa_transaction_headers th_rt,
              fa_books books,
              fa_distribution_history dh,
              fa_category_books cb
     WHERE cb.book_type_code = book_type_code_
         AND cb.category_id = ah.category_id
         AND ah.asset_id = dh.asset_id
         AND ah.date_effective < NVL (th.date_effective, ucd_)
         AND NVL (ah.date_ineffective, SYSDATE) >= NVL (th.date_effective, ucd_)
         AND --  AH.ASSET_TYPE                   = 'CAPITALIZED'
              dd_bonus.book_type_code = book_type_code_
         AND dd_bonus.distribution_id = dh.distribution_id
         AND dd_bonus.period_counter =
          (SELECT MAX (dd_sub.period_counter)
             FROM fa_deprn_detail dd_sub
            WHERE dd_sub.book_type_code = book_type_code_
              AND dd_sub.asset_id = dh.asset_id
              AND dd_sub.distribution_id = dh.distribution_id
              AND dd_sub.period_counter <= upc_)
        AND th_rt.book_type_code = book_type_code_
        AND th_rt.transaction_header_id = books.transaction_header_id_in
        AND books.book_type_code = book_type_code_
        AND books.asset_id = dh.asset_id
        AND NVL (books.period_counter_fully_retired, upc_) >= tpc_
        AND books.date_effective <= NVL (th.date_effective, ucd_)
        AND NVL (books.date_ineffective, SYSDATE + 1) > NVL (th.date_effective, ucd_)
        AND th.book_type_code(+) = book_type_code_
        AND th.transaction_header_id(+) = dh.transaction_header_id_out
        AND th.date_effective(+) BETWEEN tod_ AND ucd_
        AND dh.book_type_code = book_type_code_
        AND dh.date_effective <= ucd_
        AND NVL (dh.date_ineffective, SYSDATE) > tod_
    UNION ALL
    SELECT dh.asset_id asset_id,
       dh.code_combination_id dh_ccid,
       --APPS_GL_CODE_COMB_UTIL_API.Get_Segment2(dh.code_combination_id) segment2,       
       cb.bonus_deprn_reserve_acct rsv_account,
       books.date_placed_in_service start_date,
       books.deprn_method_code method,
       books.life_in_months life,
       books.adjusted_rate rate,
       books.production_capacity capacity,
       0 cost,
       DECODE (dd.period_counter, upc_, dd.bonus_deprn_amount, 0) deprn_amount,
       DECODE (SIGN (tpc_ - dd.period_counter), 1, 0, dd.bonus_ytd_deprn) ytd_deprn,
       dd.bonus_deprn_reserve deprn_reserve,
       0 percent,
       'B' t_type,
       dd.period_counter,
       NVL (th.date_effective, ucd_),
       cb.bonus_deprn_expense_acct,
       --To_Char(NVL (th.date_effective, ucd_),'YYYY') year_,
       --To_Char(NVL (th.date_effective, ucd_),'MM') period_,
       Apps_FA_Util_API.Get_Category_Segment1( ah.category_id) Category_Segment1,
       Apps_FA_Util_API.Get_Category_Segment2( ah.category_id) Category_Segment2
    FROM fa_deprn_detail dd,
            fa_asset_history ah,
            fa_transaction_headers th,
            fa_transaction_headers th_rt,
            fa_books books,
            fa_distribution_history dh,
            fa_category_books cb
    WHERE cb.book_type_code = book_type_code_
         AND cb.category_id = ah.category_id
         AND ah.asset_id = dh.asset_id
         AND ah.date_effective < NVL (th.date_effective, ucd_)
         AND NVL (ah.date_ineffective, SYSDATE) >= NVL (th.date_effective, ucd_)
         AND --AH.ASSET_TYPE                   = 'CAPITALIZED'
               dd.book_type_code = book_type_code_
        AND dd.distribution_id = dh.distribution_id
        AND dd.period_counter =
          (SELECT MAX (dd_sub.period_counter)
             FROM fa_deprn_detail dd_sub
            WHERE dd_sub.book_type_code = book_type_code_
              AND dd_sub.asset_id = dh.asset_id
              AND dd_sub.distribution_id = dh.distribution_id
              AND dd_sub.period_counter <= upc_)
        AND th_rt.book_type_code = book_type_code_
        AND th_rt.transaction_header_id = books.transaction_header_id_in
        AND books.book_type_code = book_type_code_
        AND books.asset_id = dh.asset_id
        AND NVL (books.period_counter_fully_retired, upc_) >= tpc_
        AND books.date_effective <= NVL (th.date_effective, ucd_)
        AND NVL (books.date_ineffective, SYSDATE + 1) > NVL (th.date_effective, ucd_)
        AND books.bonus_rule IS NOT NULL
        AND th.book_type_code(+) = book_type_code_
        AND th.transaction_header_id(+) = dh.transaction_header_id_out
        AND th.date_effective(+) BETWEEN tod_ AND ucd_
        AND dh.book_type_code = book_type_code_
        AND dh.date_effective <= ucd_
        AND NVL (dh.date_ineffective, SYSDATE) > tod_
        )   x
       GROUP BY year_,  period_num_, period_name_,  'EBS'  , Category_Segment1,  Category_Segment2,  book_type_code_
        -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    UNION
        SELECT  year_,  period_num_, period_name_  Period_Name,  'BO' system_, Category_Segment1,  Category_Segment2,  Sum(cost) cost_, Sum(deprn_amount) deprn_amount,  Sum(deprn_reserve) Deprn_reserve,  Sum(ytd_deprn) ytd_deprn,  (Sum(cost) - Sum(deprn_reserve)) Nbv, book_type_code_
           FROM
       (SELECT apps_appl.fa_additions_b.asset_id,
            DECODE (apps_appl.fa_deprn_detail.deprn_source_code, 'B', apps_appl.fa_deprn_detail.addition_cost_to_clear, apps_appl.fa_deprn_detail.cost) cost,
            DECODE (apps_appl.fa_deprn_detail.period_counter,TO_NUMBER (LTRIM (RTRIM (apps_fa_util_api.get_deprn_period_param (apps_appl.fa_distribution_history.book_type_code, period_name_, 'UPC')))),   
                apps_appl.fa_deprn_detail.deprn_amount - apps_appl.fa_deprn_detail.bonus_deprn_amount,  0)   deprn_amount,
            apps_appl.fa_deprn_detail.deprn_reserve - NVL (apps_appl.fa_deprn_detail.bonus_deprn_amount, 0) deprn_reserve,
             DECODE (SIGN (  To_NUMBER(Ltrim(Rtrim(Apps_FA_Util_API.Get_Deprn_Period_Param (APPS_APPL.FA_DISTRIBUTION_HISTORY.book_type_code, 
                 period_name_, 'TPC')))) - APPS_APPL.FA_DEPRN_DETAIL.period_counter), 1, 0, APPS_APPL.FA_DEPRN_DETAIL.ytd_deprn - APPS_APPL.FA_DEPRN_DETAIL.bonus_ytd_deprn) ytd_deprn,
           --To_Char(NVL (th.date_effective, ucd_),'YYYY') year_,
           --To_Char(NVL (th.date_effective, ucd_),'MM') period_,
           Apps_FA_Util_API.Get_Category_Segment1( apps_appl.fa_asset_history.category_id) Category_Segment1,
           Apps_FA_Util_API.Get_Category_Segment2( apps_appl.fa_asset_history.category_id) Category_Segment2
            FROM apps_appl.fa_category_books,
                      apps_appl.fa_additions_b,
                      apps_appl.fa_deprn_detail,
                      apps_appl.fa_distribution_history,
                      apps_appl.fa_books,
                      apps_appl.fa_asset_history,
                      apps_appl.fa_deprn_summary
         WHERE (apps_appl.fa_asset_history.asset_id = apps_appl.fa_additions_b.asset_id)
              AND (apps_appl.fa_additions_b.asset_id = apps_appl.fa_books.asset_id)
              AND (apps_appl.fa_books.book_type_code = apps_appl.fa_deprn_summary.book_type_code
              AND apps_appl.fa_books.asset_id = apps_appl.fa_deprn_summary.asset_id)
              AND (apps_appl.fa_category_books.category_id = apps_appl.fa_asset_history.category_id
              AND apps_appl.fa_category_books.book_type_code =   apps_fa_util_api.get_asset_book_type_code (apps_appl.fa_asset_history.asset_id) )
              AND (apps_appl.fa_deprn_summary.book_type_code = apps_appl.fa_deprn_detail.book_type_code
              AND apps_appl.fa_deprn_summary.asset_id = apps_appl.fa_deprn_detail.asset_id
              AND apps_appl.fa_deprn_summary.period_counter = apps_appl.fa_deprn_detail.period_counter)
              AND (apps_appl.fa_deprn_detail.book_type_code = apps_appl.fa_distribution_history.book_type_code
              AND apps_appl.fa_deprn_detail.distribution_id = apps_appl.fa_distribution_history.distribution_id)
              AND (apps_appl.fa_books.book_type_code = book_type_code_
              AND (apps_fa_util_api.get_deprn_period_counter (
                apps_appl.fa_books.book_type_code,
                apps_fa_util_api.get_asset_entered_period (apps_appl.fa_books.asset_id, apps_appl.fa_books.book_type_code)) <=
                apps_fa_util_api.get_deprn_period_counter (apps_appl.fa_books.book_type_code, period_name_))
             AND (apps_fa_util_api.get_deprn_period_end_date (apps_appl.fa_books.book_type_code, period_name_) BETWEEN apps_appl.fa_books.date_effective
                                                                                                          AND NVL ( apps_appl.fa_books.date_ineffective, SYSDATE + 1))
            AND ( (apps_fa_util_api.get_deprn_period_end_date (apps_appl.fa_distribution_history.book_type_code, period_name_) BETWEEN apps_appl.fa_distribution_history.date_effective
                                                                                                                           AND NVL ( apps_appl.fa_distribution_history.date_ineffective, SYSDATE + 1)
                OR (apps_fa_util_api.get_deprn_period_start_date (apps_appl.fa_distribution_history.book_type_code, period_name_) BETWEEN apps_appl.fa_distribution_history.date_effective
                                                                                                                              AND apps_appl.fa_distribution_history.date_ineffective
                        AND apps_appl.fa_distribution_history.date_ineffective IS NOT NULL)))
            AND (apps_appl.fa_deprn_detail.distribution_id = apps_appl.fa_distribution_history.distribution_id
            AND apps_appl.fa_deprn_detail.period_counter =
                (SELECT MAX (dd_sub.period_counter)
                    FROM apps_appl.fa_deprn_detail dd_sub
                 WHERE dd_sub.book_type_code = apps_appl.fa_distribution_history.book_type_code
                      AND dd_sub.asset_id = apps_appl.fa_distribution_history.asset_id
                      AND dd_sub.distribution_id = apps_appl.fa_distribution_history.distribution_id
                      AND dd_sub.period_counter <=
                        TO_NUMBER ( LTRIM ( RTRIM ( apps_fa_util_api.get_deprn_period_param (apps_appl.fa_distribution_history.book_type_code, period_name_, 'UPC'))))  )  )
                      AND (apps_fa_util_api.get_deprn_period_end_date (
                                apps_fa_util_api.get_asset_book_type_code (apps_appl.fa_asset_history.asset_id), period_name_) BETWEEN apps_appl.fa_asset_history.date_effective
                              AND NVL (apps_appl.fa_asset_history.date_ineffective, SYSDATE + 1))
                        AND (NVL (
                            apps_appl.fa_books.period_counter_fully_retired,
                            TO_NUMBER (LTRIM ( RTRIM ( apps_fa_util_api.get_deprn_period_param (apps_appl.fa_distribution_history.book_type_code, period_name_, 'UPC'))))) >=
                            TO_NUMBER ( LTRIM ( RTRIM ( apps_fa_util_api.get_deprn_period_param (apps_appl.fa_distribution_history.book_type_code, period_name_, 'TPC')))))
                    AND (apps_appl.fa_books.book_type_code IN (SELECT sav_fa_book_access.book_type_code
                                                 FROM sav_fa_book_access
                                                WHERE sav_fa_book_access.user_id = (SELECT UPPER ('ibaig') FROM DUAL))        ))
             ) y
            GROUP BY year_,  period_num_,  period_name_,  'ORACLE',  Category_Segment1,  Category_Segment2,  book_type_code_;
  END LOOP;
  Commit;
 
END Calc_BO_EBS_Tot_For_CatGrp;



END;

/
