CREATE  PACKAGE         APPS_GL_CODE_COMB_UTIL_API AS

FUNCTION Get_Segment1_Description (
  segment1_      IN VARCHAR2 ) RETURN VARCHAR2;


FUNCTION Get_Segment2_Description (
  segment2_      IN VARCHAR2 ) RETURN VARCHAR2;


FUNCTION Get_Segment3_Description (
  segment3_      IN VARCHAR2 ) RETURN VARCHAR2;


FUNCTION Get_Segment4_Description (
  segment3_      IN VARCHAR2,
  segment4_      IN VARCHAR2 ) RETURN VARCHAR2;


FUNCTION Get_Segment5_Description (
  segment5_      IN VARCHAR2 ) RETURN VARCHAR2;


FUNCTION Get_Segment6_Description (
  segment6_      IN VARCHAR2 ) RETURN VARCHAR2;


FUNCTION Get_Full_Segment (
  code_combination_id_      IN NUMBER ) RETURN VARCHAR2;

FUNCTION Get_Segment1 (
  code_combination_id_      IN NUMBER ) RETURN VARCHAR2;
  
FUNCTION Get_Segment2 (
  code_combination_id_      IN NUMBER ) RETURN VARCHAR2;

FUNCTION Get_Segment3 (
  code_combination_id_      IN NUMBER ) RETURN VARCHAR2;
    
END;

/
CREATE  PACKAGE BODY         APPS_GL_CODE_COMB_UTIL_API AS

FUNCTION Get_Segment1_Description (
  segment1_      IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT ---SUBSTR (gl_code_combinations.segment1, 1, 10) AS flex_value,
            DISTINCT fnd_flex_values_tl.description  description
       FROM GL_Code_Combinations,
                   Fnd_Flex_Values_tl,
                   Fnd_Flex_Values
      WHERE fnd_flex_values.flex_value_set_id = 103251
          AND gl_code_combinations.segment1 = fnd_flex_values.flex_value
          AND fnd_flex_values.flex_value_id = fnd_flex_values_tl.flex_value_id
          AND fnd_flex_values_tl.language = 'US'
          AND SUBSTR (gl_code_combinations.segment1, 1, 10)  = segment1_;
    --GROUP BY SUBSTR (gl_code_combinations.segment1, 1, 10),
    --         fnd_flex_values_tl.description;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Segment1_Description;


FUNCTION Get_Segment2_Description (
  segment2_      IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
    SELECT  DISTINCT ---SUBSTR (gl_code_combinations.segment2, 1, 10) AS flex_value,
            fnd_flex_values_tl2.description AS description
       FROM gl_code_combinations,
                   fnd_flex_values_tl fnd_flex_values_tl2,
                   fnd_flex_values fnd_flex_values2
      WHERE gl_code_combinations.segment2 = fnd_flex_values2.flex_value
          AND fnd_flex_values2.flex_value_id = fnd_flex_values_tl2.flex_value_id
          AND fnd_flex_values2.flex_value_set_id = 1000133
          AND fnd_flex_values_tl2.language = 'US'
          AND gl_code_combinations.segment2 = segment2_;
   --GROUP BY SUBSTR (gl_code_combinations.segment2, 1, 10),
   --         fnd_flex_values_tl2.description;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Segment2_Description;


FUNCTION Get_Segment3_Description (
  segment3_      IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT DISTINCT ---SUBSTR (gl_code_combinations.segment3, 1, 10) AS flex_value,
            fnd_flex_values_tl.description AS description
            --fnd_flex_values3.attribute1 AS main_acc_desc_ar
       FROM GL_Code_Combinations,
                Fnd_Flex_Values_tl,
                Fnd_Flex_Values
      WHERE fnd_flex_values.flex_value_set_id = 103253
          AND gl_code_combinations.segment3 = fnd_flex_values.flex_value
          AND fnd_flex_values.flex_value_id = fnd_flex_values_tl.flex_value_id
          AND Fnd_Flex_Values_tl.language = 'US'
          AND gl_code_combinations.segment3 = segment3_;
--   GROUP BY SUBSTR (gl_code_combinations.segment3, 1, 10),
--            fnd_flex_values_tl.description,
--            fnd_flex_values3.attribute1;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Segment3_Description;


FUNCTION Get_Segment4_Description (
  segment3_      IN VARCHAR2,
  segment4_      IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT distinct --SUBSTR (gl_code_combinations.segment4, 1, 10) AS flex_value,
            fnd_flex_values_tl.description AS description
       FROM GL_Code_Combinations,
                Fnd_Flex_Values_tl,
                Fnd_Flex_Values
      WHERE fnd_flex_values.flex_value_set_id = 103256
          AND gl_code_combinations.segment4 = fnd_flex_values.flex_value
          AND fnd_flex_values.flex_value_id = fnd_flex_values_tl.flex_value_id
          AND Fnd_Flex_Values_tl.language = 'US'
          AND gl_code_combinations.segment3 = fnd_flex_values.parent_flex_value_low
          AND gl_code_combinations.segment3 = segment3_
          AND gl_code_combinations.segment4 = segment4_;
   --GROUP BY SUBSTR (gl_code_combinations.segment4, 1, 10),
   --         fnd_flex_values_tl.description;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Segment4_Description;


FUNCTION Get_Segment5_Description (
  segment5_      IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
     SELECT DISTINCT ---SUBSTR (gl_code_combinations.segment5, 1, 10) AS flex_value,
                fnd_flex_values_tl.description AS description
            ---Decode(gl_code_combinations.account_type,'R', 'Revenue','A','Assets','L','Liabilities','E','Expense','O','Owners Equity') Account_Type
       FROM GL_Code_Combinations,
                Fnd_Flex_Values_tl,
                Fnd_Flex_Values
      WHERE fnd_flex_values.flex_value_set_id = 103254
          AND gl_code_combinations.segment5 = fnd_flex_values.flex_value
          AND fnd_flex_values.flex_value_id = fnd_flex_values_tl.flex_value_id
          AND gl_code_combinations.segment5 = segment5_;
 --  GROUP BY SUBSTR (gl_code_combinations.segment5, 1, 10),
--            fnd_flex_values_tl.description,
--            gl_code_combinations.account_type;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Segment5_Description;


FUNCTION Get_Segment6_Description (
  segment6_      IN VARCHAR2 ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
    SELECT distinct --SUBSTR (gl_code_combinations.segment7, 1, 10) AS flex_value,
            fnd_flex_values_tl.description AS description  --region
       FROM GL_Code_Combinations,
                Fnd_Flex_Values_tl,
                Fnd_Flex_Values
      WHERE fnd_flex_values.flex_value_set_id = 103255
          AND gl_code_combinations.segment6 = fnd_flex_values.flex_value
          AND fnd_flex_values.flex_value_id = fnd_flex_values_tl.flex_value_id
          AND gl_code_combinations.segment6 = segment6_;
   --GROUP BY SUBSTR (gl_code_combinations.segment7, 1, 10),
   --         fnd_flex_values_tl.description;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Segment6_Description;


FUNCTION Get_Full_Segment (
  code_combination_id_      IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
    SELECT segment1||'-'||segment2||'-'||segment3||'-'||segment4||'-'||segment5||'-'||segment6||'-'||segment7||'-'||segment8
      FROM GL_Code_Combinations
     WHERE gl_code_combinations.code_combination_id = code_combination_id_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Full_Segment;


FUNCTION Get_Segment1 (
  code_combination_id_      IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
    SELECT segment1
      FROM GL_Code_Combinations
     WHERE gl_code_combinations.code_combination_id = code_combination_id_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Segment1;


FUNCTION Get_Segment2 (
  code_combination_id_      IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
    SELECT segment2
      FROM GL_Code_Combinations
     WHERE gl_code_combinations.code_combination_id = code_combination_id_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Segment2;


FUNCTION Get_Segment3 (
  code_combination_id_      IN NUMBER ) RETURN VARCHAR2
IS
   temp_    VARCHAR2(250);
   CURSOR get_attr_ IS
    SELECT segment3
      FROM GL_Code_Combinations
     WHERE gl_code_combinations.code_combination_id = code_combination_id_;
BEGIN
  OPEN get_attr_;
  FETCH get_attr_ INTO temp_;
  CLOSE get_attr_;
  RETURN temp_;
END Get_Segment3;


END;

/
