/* Formatted on 20/01/2013 6:40:13 PM (QP5 v5.240.12305.39446) */
CREATE OR REPLACE FORCE VIEW sav_fa_asset_reclassify_v
(
   book_type_code,
   comp_code,
   fr_as_account,
   fr_re_account,
   fr_category,
   to_as_account,
   to_re_account,
   to_category,
   asset_number,
   cost_adj,
   res_adj,
   th_id,
   transaction_date_entered,
   asset_id,
   trans_period_name
) AS
     SELECT                                                                              --ACCT_FLEX_BAL_SEG              COMP_CODE,
           th.book_type_code,
            dhcc.segment1 comp_code,
            DECODE (fah.asset_type, 'CIP', fcb.cip_cost_acct, fcb.asset_cost_acct) fr_as_account,
            DECODE (fah.asset_type, 'CIP', ' ', fcb.deprn_reserve_acct) fr_re_account,
            ---CAT_FLEX_ALL_SEG_FR                 FR_CATEGORY,
            fcat.segment1 fr_category,
            DECODE (tah.asset_type, 'CIP', tcb.cip_cost_acct, tcb.asset_cost_acct) to_as_account,
            DECODE (tah.asset_type, 'CIP', ' ', tcb.deprn_reserve_acct) to_re_account,
            ---CAT_FLEX_ALL_SEG_TO                TO_CATEGORY,
            tcat.segment1 to_category,
            ad.asset_number asset_number,
            AVG (DECODE (cost_adj.debit_credit_flag,  'DR', 1,  'CR', -1) * cost_adj.adjustment_amount) cost_adj,
            AVG (DECODE (res_adj.debit_credit_flag,  'DR', -1,  'CR', 1) * NVL (res_adj.adjustment_amount, 0)) res_adj,
            th.transaction_header_id th_id,
            th.transaction_date_entered,
            th.asset_id,
            apps_fa_util_api.get_deprn_period_name_by_date (th.book_type_code, th.date_effective) trans_period_name
       FROM fa_deprn_periods dp,
            fa_deprn_periods start_dp,
            fa_deprn_periods end_dp,
            fa_additions ad,
            gl_code_combinations dhcc,
            fa_categories fcat,
            fa_categories tcat,
            fa_category_books fcb,
            fa_category_books tcb,
            fa_transaction_headers th,
            fa_adjustments cost_adj,
            fa_adjustments res_adj,
            fa_asset_history fah,
            fa_asset_history tah,
            fa_distribution_history dh
      WHERE                                                                                      --start_dp.period_name = :p_period1
            --AND end_dp.period_name = :p_period2
            -- start_dp.book_type_code = UPPER (:p_book)
            end_dp.book_type_code = start_dp.book_type_code
        AND dp.book_type_code = start_dp.book_type_code
        AND dp.period_counter >= start_dp.period_counter
        AND dp.period_counter <= NVL (end_dp.period_counter, dp.period_counter)
        ---AND th.book_type_code = :p_book
        AND th.book_type_code = dp.book_type_code
        AND th.transaction_type_code = 'RECLASS'
        AND th.date_effective >= dp.period_open_date
        AND th.date_effective <= NVL (dp.period_close_date, SYSDATE)
        --AND fah.book_type_code = th.book_type_code
        AND ad.asset_id = th.asset_id
        AND fah.asset_id = th.asset_id
        AND fah.date_ineffective = th.date_effective
        AND tah.asset_id = th.asset_id
        AND tah.date_effective = th.date_effective
        AND tcat.category_id = tah.category_id
        AND fcat.category_id = fah.category_id
        ---AND tcb.book_type_code = UPPER (:p_book)

        --AND tcb.book_type_code = tah.book_type_code
        AND tcb.book_type_code = fcb.book_type_code
        AND tcb.category_id = tah.category_id
        ---AND fcb.book_type_code = UPPER (:p_book)
        AND fcb.category_id = fah.category_id
        AND cost_adj.transaction_header_id = th.transaction_header_id
        AND cost_adj.book_type_code = th.book_type_code
        ---AND cost_adj.book_type_code = :p_book
        AND cost_adj.source_type_code = 'RECLASS'
        AND cost_adj.adjustment_type IN ('COST', 'CIP COST')
        AND cost_adj.period_counter_created >= start_dp.period_counter
        AND cost_adj.period_counter_created <= NVL (end_dp.period_counter, dp.period_counter)
        AND res_adj.transaction_header_id(+) = cost_adj.transaction_header_id
        AND res_adj.asset_id(+) = cost_adj.asset_id
        AND res_adj.distribution_id(+) = cost_adj.distribution_id
        ---AND res_adj.book_type_code(+) = UPPER (:p_book)

        AND res_adj.book_type_code(+) = cost_adj.book_type_code
        AND res_adj.source_type_code(+) = 'RECLASS'
        AND res_adj.adjustment_type(+) = 'RESERVE'
        AND res_adj.period_counter_created(+) = cost_adj.period_counter_created
        AND res_adj.adjustment_amount(+) != 0
        --AND dh.book_type_code = :p_book
        AND dh.book_type_code = th.book_type_code
        AND dh.asset_id = th.asset_id
        AND dh.transaction_header_id_in = NVL (th.source_transaction_header_id, th.transaction_header_id)
        AND dh.distribution_id = cost_adj.distribution_id
        AND dhcc.code_combination_id = dh.code_combination_id
   GROUP BY                                                                                                     --ACCT_FLEX_BAL_SEG,
           th.book_type_code,
            dhcc.segment1,
            DECODE (fah.asset_type, 'CIP', fcb.cip_cost_acct, fcb.asset_cost_acct),
            DECODE (fah.asset_type, 'CIP', ' ', fcb.deprn_reserve_acct),
            --CAT_FLEX_ALL_SEG_FR,
            fcat.segment1,
            DECODE (tah.asset_type, 'CIP', tcb.cip_cost_acct, tcb.asset_cost_acct),
            DECODE (tah.asset_type, 'CIP', ' ', tcb.deprn_reserve_acct),
            --CAT_FLEX_ALL_SEG_TO,
            tcat.segment1,
            ad.asset_number,
            th.transaction_header_id,
            th.transaction_date_entered,
            th.asset_id,
            apps_fa_util_api.get_deprn_period_name_by_date (th.book_type_code, th.date_effective)
   ORDER BY 1, LPAD (DECODE (fah.asset_type, 'CIP', fcb.cip_cost_acct, fcb.asset_cost_acct), 25, '0'), ad.asset_number;


/* Formatted on 20/01/2013 6:40:13 PM (QP5 v5.240.12305.39446) */
CREATE OR REPLACE FORCE VIEW sav_fa_asset_transfers_v
(
   book_type_code,
   asset_id,
   asset_number,
   description,
   transnum,
   to_from,
   segment1,
   segment2,
   segment3,
   location_segment,
   transaction_date,
   assigned_to,
   ccid,
   cost,
   deprn_reserve,
   units,
   trans_period_name
) AS
     SELECT book_type_code,
            asset_id,
            asset_number,
            description,
            transnum,
            AVG (to_from) to_from,
            segment1,
            segment2,
            segment3,
            location_segment,
            transaction_date,
            assigned_to,
            ccid,
            SUM (cost) cost,
            SUM (deprn_reserve) deprn_reserve,
            AVG (units) units,
            trans_period_name
       FROM (  SELECT th.book_type_code,
                      ad.asset_id,
                      ad.asset_number,
                      ad.description,
                      th.transaction_header_id transnum,
                      DECODE (th.transaction_header_id,  dh.transaction_header_id_in, 1,  dh.transaction_header_id_out, 0) to_from,
                      --ACCT_FLEX_ACCT_SEG     GL_ACCOUNT,
                      --ACCT_FLEX_BAL_SEG  COMP_CODE,
                      --ACCT_FLEX_COST_SEG     COST_CENTER,
                      --        LOC_FLEX_ALL_SEG       LOCATION,
                      ascc.segment1,
                      ascc.segment2,
                      ascc.segment3,
                         loc.segment1
                      || '-'
                      || loc.segment2
                      || '-'
                      || loc.segment3
                      || '-'
                      || loc.segment4
                      || '-'
                      || loc.segment5
                      || '-'
                      || loc.segment6
                      || '-'
                      || loc.segment7
                         location_segment,
                      th.transaction_date_entered transaction_date,
                      dh.assigned_to assigned_to,
                      ascc.code_combination_id ccid,
                      SUM (cadj.adjustment_amount * DECODE (cadj.debit_credit_flag,  'CR', -1,  'DR', 1)) cost,
                      0 deprn_reserve,
                      SUM (
                         DISTINCT   DECODE (th.transaction_header_id,
                                            dh.transaction_header_id_in, 1,
                                            dh.transaction_header_id_out, -1)
                                  * dh.units_assigned)
                         units,
                      apps_fa_util_api.get_deprn_period_name_by_date (th.book_type_code, th.date_effective) trans_period_name
                 FROM fa_locations loc,
                      fa_additions ad,
                      gl_code_combinations ascc,
                      fa_distribution_history dh,
                      fa_transaction_headers th,
                      fa_adjustments cadj
                WHERE                                                                                   --th.book_type_code = p_book
                     th.transaction_type_code = 'TRANSFER'
                  ---AND    TH.DATE_EFFECTIVE     >=  :PERIOD1_POD AND    TH.DATE_EFFECTIVE     <=  :PERIOD1_PCD
                  --AND    nvl(TH.MASS_REFERENCE_ID, 0)    =    NVL(:P_MASS_REF_ID, nvl(TH.MASS_REFERENCE_ID, 0))
                  AND (th.transaction_header_id = dh.transaction_header_id_in
                    OR th.transaction_header_id = dh.transaction_header_id_out)
                  AND ad.asset_id = th.asset_id
                  AND loc.location_id = dh.location_id
                  AND ascc.code_combination_id = dh.code_combination_id
                  AND cadj.book_type_code = th.book_type_code                                                             ---:p_book
                  AND cadj.asset_id = th.asset_id
                  AND cadj.distribution_id = dh.distribution_id
                  AND cadj.transaction_header_id = th.transaction_header_id
                  AND cadj.source_type_code = 'TRANSFER'
                  AND cadj.adjustment_type IN ('COST', 'CIP COST')
             --LP_WHERE_CLAUSE1
             GROUP BY th.book_type_code,
                      th.transaction_header_id,
                      DECODE (th.transaction_header_id,  dh.transaction_header_id_in, 1,  dh.transaction_header_id_out, 0),
                      dh.distribution_id,
                      --ACCT_FLEX_ACCT_SEG,
                      --ACCT_FLEX_BAL_SEG,
                      --ACCT_FLEX_COST_SEG,
                      --LOC_FLEX_ALL_SEG,
                      ascc.segment1,
                      ascc.segment2,
                      ascc.segment3,
                         loc.segment1
                      || '-'
                      || loc.segment2
                      || '-'
                      || loc.segment3
                      || '-'
                      || loc.segment4
                      || '-'
                      || loc.segment5
                      || '-'
                      || loc.segment6
                      || '-'
                      || loc.segment7,
                      ad.asset_number,
                      ad.description,
                      th.transaction_date_entered,
                      dh.assigned_to,
                      ascc.code_combination_id,
                      ad.asset_id,
                      apps_fa_util_api.get_deprn_period_name_by_date (th.book_type_code, th.date_effective)
             UNION
               SELECT th.book_type_code,
                      ad.asset_id,
                      ad.asset_number,
                      ad.description,
                      th.transaction_header_id transnum,
                      DECODE (th.transaction_header_id,  dh.transaction_header_id_in, 1,  dh.transaction_header_id_out, 0) to_from,
                      --ACCT_FLEX_ACCT_SEG     GL_ACCOUNT,
                      --ACCT_FLEX_BAL_SEG  COMP_CODE,
                      --ACCT_FLEX_COST_SEG     COST_CENTER,
                      --LOC_FLEX_ALL_SEG       LOCATION,
                      ascc.segment1,
                      ascc.segment2,
                      ascc.segment3,
                         loc.segment1
                      || '-'
                      || loc.segment2
                      || '-'
                      || loc.segment3
                      || '-'
                      || loc.segment4
                      || '-'
                      || loc.segment5
                      || '-'
                      || loc.segment6
                      || '-'
                      || loc.segment7
                         location_segment,
                      th.transaction_date_entered start_date,
                      dh.assigned_to assigned_to,
                      ascc.code_combination_id ccid,
                      0 cost,
                      SUM (NVL (radj.adjustment_amount, 0) * DECODE (NVL (radj.debit_credit_flag, 'CR'),  'CR', 1,  'DR', -1))
                         deprn_reserve,
                      SUM (
                         DISTINCT   DECODE (th.transaction_header_id,
                                            dh.transaction_header_id_in, 1,
                                            dh.transaction_header_id_out, -1)
                                  * dh.units_assigned)
                         units,
                      apps_fa_util_api.get_deprn_period_name_by_date (th.book_type_code, th.date_effective) trans_period_name
                 FROM fa_locations loc,
                      fa_additions ad,
                      gl_code_combinations ascc,
                      fa_distribution_history dh,
                      fa_transaction_headers th,
                      fa_adjustments radj
                WHERE                                                                                   --th.book_type_code = p_book
                     th.transaction_type_code = 'TRANSFER'
                  ---    AND    TH.DATE_EFFECTIVE     >=  :PERIOD1_POD AND    TH.DATE_EFFECTIVE     <=  :PERIOD1_PCD
                  --AND    nvl(TH.MASS_REFERENCE_ID, 0)    =   NVL(:P_MASS_REF_ID, nvl(TH.MASS_REFERENCE_ID, 0))
                  AND (th.transaction_header_id = dh.transaction_header_id_in
                    OR th.transaction_header_id = dh.transaction_header_id_out)
                  AND ad.asset_id = th.asset_id
                  AND loc.location_id = dh.location_id
                  AND ascc.code_combination_id = dh.code_combination_id
                  AND radj.book_type_code = th.book_type_code                                                             ---:p_book
                  AND radj.asset_id = th.asset_id
                  AND radj.distribution_id = dh.distribution_id
                  AND radj.source_type_code = 'TRANSFER'
                  AND radj.adjustment_type = 'RESERVE'
                  AND radj.transaction_header_id = th.transaction_header_id
             ---LP_WHERE_CLAUSE2
             GROUP BY th.book_type_code,
                      th.transaction_header_id,
                      DECODE (th.transaction_header_id,  dh.transaction_header_id_in, 1,  dh.transaction_header_id_out, 0),
                      dh.distribution_id,
                      --ACCT_FLEX_ACCT_SEG,
                      --ACCT_FLEX_BAL_SEG,
                      --ACCT_FLEX_COST_SEG,
                      --LOC_FLEX_ALL_SEG,
                      ascc.segment1,
                      ascc.segment2,
                      ascc.segment3,
                         loc.segment1
                      || '-'
                      || loc.segment2
                      || '-'
                      || loc.segment3
                      || '-'
                      || loc.segment4
                      || '-'
                      || loc.segment5
                      || '-'
                      || loc.segment6
                      || '-'
                      || loc.segment7,
                      ad.asset_id,
                      ad.asset_number,
                      ad.description,
                      th.transaction_date_entered,
                      dh.assigned_to,
                      ascc.code_combination_id,
                      apps_fa_util_api.get_deprn_period_name_by_date (th.book_type_code, th.date_effective)
             ORDER BY 1,
                      3,
                      5,
                      6,
                      7,
                      8,
                      9,
                      10)
   ---WHERE book_type_code = :book_type_code_
   GROUP BY book_type_code,
            asset_id,
            asset_number,
            description,
            transnum,
            segment1,
            segment2,
            segment3,
            location_segment,
            transaction_date,
            assigned_to,
            ccid,
            trans_period_name
   ORDER BY 1,
            3,
            5,
            6,
            7,
            8,
            9,
            10;


/* Formatted on 20/01/2013 6:40:13 PM (QP5 v5.240.12305.39446) */
CREATE OR REPLACE FORCE VIEW sav_fa_fintrans_inquiry_v
(
   transaction_header_id_in,
   asset_id,
   asset_number,
   book_type_code,
   transaction_type,
   transaction_key,
   transaction_subtype,
   transaction_comments,
   transaction_date_entered,
   invoice_transaction_id,
   period_entered,
   period_effective,
   fiscal_year,
   period_counter,
   deprn_period_num,
   deprn_period_open_date,
   deprn_period_close_date,
   calendar_period_open_date,
   calendar_period_close_date,
   transaction_header_id_out,
   current_cost,
   original_cost,
   salvage_value,
   recoverable_cost,
   deprn_method_code,
   life,
   adjusted_rate,
   production_capacity,
   unit_of_measure,
   prorate_convention_code,
   prorate_date,
   date_placed_in_service,
   depreciate_flag,
   bonus_rule,
   ceiling_name,
   revaluation_ceiling,
   adjusted_recoverable_cost
) AS
   SELECT bk.transaction_header_id_in transaction_header_id_in,
          bk.asset_id,
          ad.asset_number,
          bk.book_type_code,
          lo.meaning transaction_type,
          th.transaction_key,
          th.transaction_subtype,
          th.transaction_name transaction_comments,
          th.transaction_date_entered,
          th.invoice_transaction_id,
          dp.period_name period_entered,
          cp.period_name period_effective,
          dp.fiscal_year,
          dp.period_counter,
          dp.period_num deprn_period_num,
          dp.period_open_date deprn_period_open_date,
          dp.period_close_date deprn_period_close_date,
          cp.start_date calendar_period_open_date,
          cp.end_date calendar_period_close_date,
          bk.transaction_header_id_out transaction_header_id_out,
          bk.cost current_cost,
          bk.original_cost original_cost,
          bk.salvage_value,
          bk.recoverable_cost,
          bk.deprn_method_code deprn_method_code,
          fnd_number.canonical_to_number (NVL (TRUNC (bk.life_in_months / 12), 0) || '.' || NVL (MOD (bk.life_in_months, 12), 0))
             life,
          bk.adjusted_rate adjusted_rate,
          bk.production_capacity,
          bk.unit_of_measure,
          bk.prorate_convention_code,
          bk.prorate_date,
          bk.date_placed_in_service date_placed_in_service,
          bk.depreciate_flag,
          bk.bonus_rule bonus_rule,
          bk.ceiling_name ceiling_name,
          bk.reval_ceiling revaluation_ceiling,
          bk.adjusted_recoverable_cost
     FROM fa_additions_b ad,
          fa_deprn_periods dp,
          fa_calendar_periods cp,
          fa_book_controls bc,
          fa_lookups lo,
          fa_transaction_headers th,
          fa_books_bas bkprev,
          fa_books bk
    WHERE (bkprev.transaction_header_id_out(+) = bk.transaction_header_id_in AND NVL (bkprev.cost, bk.cost - 1) != bk.cost)
      AND (lo.lookup_type = 'FAXOLTRX' AND lo.lookup_code = th.transaction_type_code)
      AND bc.book_type_code = dp.book_type_code
      AND cp.calendar_type = bc.deprn_calendar
      AND th.transaction_date_entered BETWEEN cp.start_date AND cp.end_date
      AND (th.date_effective BETWEEN dp.period_open_date AND NVL (dp.period_close_date, SYSDATE)
       AND dp.book_type_code = th.book_type_code)
      AND ad.asset_id = bk.asset_id
      AND th.transaction_header_id = bk.transaction_header_id_in;


/* Formatted on 20/01/2013 6:40:13 PM (QP5 v5.240.12305.39446) */
CREATE OR REPLACE FORCE VIEW sav_fa_retirements_v
(
   ret_rowid,
   retirement_id,
   book_type_code,
   asset_id,
   transaction_header_id_in,
   date_retired,
   date_effective,
   cost_retired,
   status,
   last_update_date,
   last_updated_by,
   retirement_prorate_convention,
   transaction_header_id_out,
   units,
   cost_of_removal,
   nbv_retired,
   gain_loss_amount,
   proceeds_of_sale,
   gain_loss_type_code,
   retirement_type_code,
   itc_recaptured,
   itc_recapture_id,
   reference_num,
   sold_to,
   trade_in_asset_id,
   stl_method_code,
   stl_life_in_months,
   stl_deprn_amount,
   created_by,
   creation_date,
   last_update_login,
   ret_attribute1,
   ret_attribute2,
   ret_attribute3,
   ret_attribute4,
   ret_attribute5,
   ret_attribute6,
   ret_attribute7,
   ret_attribute8,
   ret_attribute9,
   ret_attribute10,
   ret_attribute11,
   ret_attribute12,
   ret_attribute13,
   ret_attribute14,
   ret_attribute15,
   ret_attribute_category_code,
   reval_reserve_retired,
   unrevalued_cost_retired,
   asset_number,
   cost,
   current_units,
   trade_in_asset_number,
   trade_in_asset_desc,
   transaction_name,
   attribute1,
   attribute2,
   attribute3,
   attribute4,
   attribute5,
   attribute6,
   attribute7,
   attribute8,
   attribute9,
   attribute10,
   attribute11,
   attribute12,
   attribute13,
   attribute14,
   attribute15,
   attribute_category_code,
   current_fiscal_year,
   fiscal_year_name,
   fy_start_date,
   fy_end_date,
   invoice_transaction_id,
   group_asset_id,
   recognize_gain_loss,
   recapture_reserve_flag,
   limit_proceeds_flag,
   terminal_gain_loss,
   reduction_rate,
   eofy_reserve,
   reserve_retired,
   recapture_amount,
   transaction_date_effective
) AS
   SELECT ret.ROWID ret_rowid,
          ret.retirement_id,
          ret.book_type_code,
          ret.asset_id,
          ret.transaction_header_id_in,
          ret.date_retired,
          ret.date_effective,
          ret.cost_retired,
          ret.status,
          ret.last_update_date,
          ret.last_updated_by,
          ret.retirement_prorate_convention,
          ret.transaction_header_id_out,
          ret.units,
          ret.cost_of_removal,
          ret.nbv_retired,
          ret.gain_loss_amount,
          ret.proceeds_of_sale,
          ret.gain_loss_type_code,
          ret.retirement_type_code,
          ret.itc_recaptured,
          ret.itc_recapture_id,
          ret.reference_num,
          ret.sold_to,
          ret.trade_in_asset_id,
          ret.stl_method_code,
          ret.stl_life_in_months,
          ret.stl_deprn_amount,
          ret.created_by,
          ret.creation_date,
          ret.last_update_login,
          ret.attribute1 ret_attribute1,
          ret.attribute2 ret_attribute2,
          ret.attribute3 ret_attribute3,
          ret.attribute4 ret_attribute4,
          ret.attribute5 ret_attribute5,
          ret.attribute6 ret_attribute6,
          ret.attribute7 ret_attribute7,
          ret.attribute8 ret_attribute8,
          ret.attribute9 ret_attribute9,
          ret.attribute10 ret_attribute10,
          ret.attribute11 ret_attribute11,
          ret.attribute12 ret_attribute12,
          ret.attribute13 ret_attribute13,
          ret.attribute14 ret_attribute14,
          ret.attribute15 ret_attribute15,
          ret.attribute_category_code ret_attribute_category_code,
          ret.reval_reserve_retired,
          ret.unrevalued_cost_retired,
          ad.asset_number asset_number,
          bks.cost cost,
          ah.units current_units,
          trade_in.asset_number trade_in_asset_number,
          adt.description trade_in_asset_desc,
          th.transaction_name,
          th.attribute1,
          th.attribute2,
          th.attribute3,
          th.attribute4,
          th.attribute5,
          th.attribute6,
          th.attribute7,
          th.attribute8,
          th.attribute9,
          th.attribute10,
          th.attribute11,
          th.attribute12,
          th.attribute13,
          th.attribute14,
          th.attribute15,
          th.attribute_category_code,
          bc.current_fiscal_year,
          bc.fiscal_year_name,
          fy.start_date fy_start_date,
          fy.end_date fy_end_date,
          th.invoice_transaction_id,
          bks.group_asset_id group_asset_id,
          ret.recognize_gain_loss recognize_gain_loss,
          ret.recapture_reserve_flag recapture_reserve_flag,
          ret.limit_proceeds_flag limit_proceeds_flag,
          ret.terminal_gain_loss terminal_gain_loss,
          ret.reduction_rate reduction_rate,
          ret.eofy_reserve eofy_reserve,
          ret.reserve_retired reserve_retired,
          ret.recapture_amount recapture_amount,
          th.date_effective transaction_date_effective
     FROM fa_retirements ret,
          fa_additions_b ad,
          fa_books bks,
          fa_book_controls bc,
          fa_fiscal_year fy,
          fa_asset_history ah,
          fa_additions_b trade_in,
          fa_additions_tl adt,
          fa_transaction_headers th
    WHERE ad.asset_id = ret.asset_id
      AND bks.book_type_code = ret.book_type_code
      AND bks.asset_id = ret.asset_id
      AND bks.transaction_header_id_out = ret.transaction_header_id_in
      AND bks.date_ineffective > ah.date_effective
      AND bks.date_ineffective <= NVL (ah.date_ineffective, SYSDATE)
      AND ah.asset_id = ret.asset_id
      AND trade_in.asset_id(+) = ret.trade_in_asset_id
      AND th.transaction_header_id = ret.transaction_header_id_in
      AND bc.book_type_code = ret.book_type_code
      AND fy.fiscal_year_name = bc.fiscal_year_name
      AND fy.fiscal_year = bc.current_fiscal_year
      AND adt.asset_id(+) = trade_in.asset_id
      AND adt.language(+) = USERENV ('LANG');
