CREATE TABLE SAV_FA_BOOK_ACCESS
(
  BOOK_TYPE_CODE  VARCHAR2(15 BYTE),
  USER_ID         VARCHAR2(30 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE SAV_FA_BO_RECONCILE
(
  PERIOD_NAME     VARCHAR2(10 BYTE),
  SYSTEM_NAME     VARCHAR2(10 BYTE),
  COST            NUMBER,
  DEPRN_AMOUNT    NUMBER,
  DEPRN_RESERVE   NUMBER,
  NBV             NUMBER,
  BOOK_TYPE_CODE  VARCHAR2(25 BYTE),
  YTD_DEPRN       NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE SAV_FA_BO_RECONCILE_BY_CAT
(
  YEAR               NUMBER,
  PERIOD_NUM         NUMBER,
  PERIOD_NAME        VARCHAR2(10 BYTE),
  SYSTEM_NAME        VARCHAR2(10 BYTE),
  CATEGORY_SEGMENT1  VARCHAR2(60 BYTE),
  CATEGORY_SEGMENT2  VARCHAR2(60 BYTE),
  COST               NUMBER,
  DEPRN_AMOUNT       NUMBER,
  DEPRN_RESERVE      NUMBER,
  YTD_DEPRN          NUMBER,
  NBV                NUMBER,
  BOOK_TYPE_CODE     VARCHAR2(30 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX SAV_FA_BOOK_ACCESS_UNQ ON SAV_FA_BOOK_ACCESS
(USER_ID, BOOK_TYPE_CODE)
LOGGING
NOPARALLEL;
